'use strict'
const utils = require('./utils')
const config = require('../config')
const isProduction = process.env.NODE_ENV === 'production'
const isDevelopment = process.env.NODE_ENV === 'development'
const sourceMapEnabled = isProduction
  ? config.build.productionSourceMap
  : config.dev.cssSourceMap

module.exports = {
  loaders: Object.assign({},
    utils.scriptLoaders({ts: {transpileOnly: isDevelopment, appendTsSuffixTo: [/\.vue$/]}}),
    utils.cssLoaders({
      sourceMap: sourceMapEnabled,
      extract: isProduction
    })
  ),
  cssSourceMap: sourceMapEnabled,
  cacheBusting: config.dev.cacheBusting,
  transformToRequire: {
    video: ['src', 'poster'],
    source: 'src',
    img: 'src',
    image: 'xlink:href'
  }
}
